﻿namespace TestProject;

/// <summary>
/// 그래픽스 그리기 가능형
/// </summary>
public class GraphicsDrawable : IDrawable
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 그리기 - Draw(canvas, dirtyRectangle)

    /// <summary>
    /// 그리기
    /// </summary>
    /// <param name="canvas">캔버스</param>
    /// <param name="dirtyRectangle">더티 사각형</param>
    public void Draw(ICanvas canvas, RectF dirtyRectangle)
    {
        PointF centerPoint = new PointF(dirtyRectangle.Center.X, dirtyRectangle.Center.Y);
        float  radius      = Math.Min(dirtyRectangle.Width, dirtyRectangle.Height) / 4;
        float  distance    = 0.8f * radius;

        PointF centerPoint1 = new PointF
        (
            distance * (float)Math.Cos(9 * Math.PI / 6) + centerPoint.X,
            distance * (float)Math.Sin(9 * Math.PI / 6) + centerPoint.Y
        );

        PointF centerPoint2 = new PointF
        (
            distance * (float)Math.Cos(1 * Math.PI / 6) + centerPoint.X,
            distance * (float)Math.Sin(1 * Math.PI / 6) + centerPoint.Y
        );

        PointF centerPoint3 = new PointF
        (
            distance * (float)Math.Cos(5 * Math.PI / 6) + centerPoint.X,
            distance * (float)Math.Sin(5 * Math.PI / 6) + centerPoint.Y
        );

        canvas.BlendMode = BlendMode.Multiply;

        canvas.FillColor = Colors.Cyan;

        canvas.FillCircle(centerPoint1, radius);

        canvas.FillColor = Colors.Magenta;

        canvas.FillCircle(centerPoint2, radius);

        canvas.FillColor = Colors.Yellow;

        canvas.FillCircle(centerPoint3, radius);
    }

    #endregion
}